REM notangle -- noweb tangle command for Ada programming language and text
REM             with some preprocessing of the input (depending on language
REM             in file)
REM
REM   %1: noweb file
REM   %2: module name to extract
REM   %3: target file name
REM   %4: language of target file
REM   %5: name of text file containing the special package names to be
REM       expanded (for language Ada)
REM
REM   Assumes that variable tempDirectory contains the place where the
REM   intermediate and target files should be placed.

SETLOCAL

REM ----------

SET sourceFile=%1
SET sourceFileStem=%tempDirectory%\%~n1
SET targetFile=%sourceFileStem%.txt
SET moduleName=%2

SET ntOptions=
SET language=text

IF NOT %2x == x  SET ntOptions=-R%moduleName%
IF NOT %3x == x  SET targetFile=%3
IF NOT %4x == x  SET language=%4
SET packageNameFile=%5

REM ----------

SET toolsDirectory=%~dp0
SET toolsDirectory=%toolsDirectory:~0,-1%
SET nowebFilterDirectory=%toolsDirectory%\nowebfilters

SET GAWK=%toolsDirectory%\gawk.exe
SET nowebMarkup=%toolsDirectory%\markup.exe
SET nowebNt=%toolsDirectory%\nt.exe
SET gawkOptions=-v configFileName="%packageNameFile%"
SET adaPackageFilter=%nowebFilterDirectory%\adapackagefilter.awk

REM ----------

REM === execute notangle chain ===
ECHO === tangling into %moduleName% ===
SET markupFile=%sourceFileStem%.mkp
SET filteredFile=%sourceFileStem%.flt
%nowebMarkup% <%sourceFile% >%markupFile%

IF NOT %language% == ada GOTO ELSE1
    %GAWK% -f %nowebFilterDirectory%\blankfilter.awk %markupFile% >%markupFile%1
    %GAWK% -f %adaPackageFilter% %gawkOptions% %markupFile%1 >%filteredFile%
    GOTO ENDIF1
:ELSE1
    IF NOT %language% == text GOTO ELSE11
        %GAWK% -f %nowebFilterDirectory%\blankfilter.awk %markupFile% >%filteredFile%
	GOTO ENDIF11
    :ELSE11
        ECHO notangle: do not know how to process file kind %language%
    :ENDIF11
:ENDIF1

%nowebNt% %ntOptions% <%filteredFile% >%targetFile%
DEL %filteredFile% %markupFile% %markupFile%1

ENDLOCAL
