REM noweave -- noweb weave command for Ada with some preprocessing of
REM            the input
REM
REM   %1: base name of noweb file
REM   %2: name of text file containing the special package names to be
REM       expanded
REM
REM   Assumes that variable tempDirectory contains the place where the
REM   intermediate and target files should be placed.

SETLOCAL

REM ----------

SET sourceFile=%1
SET sourceFileStem=%tempDirectory%\%~n1
SET targetFile=%sourceFileStem%.tex
SET packageNameFile=%2

SET delayOption=-delay

REM ----------

SET toolsDirectory=%~dp0
SET toolsDirectory=%toolsDirectory:~0,-1%
SET nowebFilterDirectory=%toolsDirectory%\nowebfilters

SET GAWK=%toolsDirectory%\gawk.exe
SET nowebMarkup=%toolsDirectory%\markup.exe
SET nowebNoidx=%toolsDirectory%\noidx.exe
SET nowebToTex=%toolsDirectory%\totex.exe

REM === execute noweave chain ===
ECHO === weaving into %~n1.tex ===
SET markupFile=%sourceFileStem%.mkp
SET filteredFile=%sourceFileStem%.tmp
%nowebMarkup% %sourceFile% | %nowebNoidx% %delayOption% >%markupFile%
SET gawkOptions=-v configFileName="%packageNameFile%"
%GAWK% -f %nowebFilterDirectory%\blankfilter.awk %markupFile% >%markupFile%1
%GAWK% -f %nowebFilterDirectory%\nw-filter.awk %gawkOptions% %markupFile%1 >%filteredFile%
%nowebToTex% <%filteredFile% %delayOption% >%targetFile%
DEL %markupFile% %markupFile%1 %filteredFile%

ENDLOCAL